//******************************************************************************
//
// Copyright (c) 2015 Microsoft Corporation. All rights reserved.
//
// This code is licensed under the MIT License (MIT).
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//******************************************************************************

#ifndef __MACH_TIME_H
#define __MACH_TIME_H

#include "mach_defs.h"

__BEGIN_DECLS

struct mach_timebase_info {
    uint32_t numer, denom;
};

__END_DECLS

typedef struct mach_timebase_info* mach_timebase_info_t;

__BEGIN_DECLS

kern_return_t mach_timebase_info(mach_timebase_info_t tinfo);
uint64_t mach_absolute_time();

__END_DECLS

#endif
